<?php

namespace chatbro\chatbroapp\Backends;

use \chatbro\chatbroapp\common\CbroCommon;
use \chatbro\chatbroapp\chats\CbroNonExistentChats;
use \chatbro\chatbroapp\exceptions\CbroChatsNotFound;
use \chatbro\chatbroapp\interfaces\IcbroChatsBackend;

class CbroChatsBackend implements IcbroChatsBackend
{

  public $non_existent_chats;
  const chat_list = "chatbro_chat_list";

  public function __construct()
  {
    $this->non_existent_chats = new CbroNonExistentChats();
  }

  function update_option($name, $value)
  {
    CbroCommon::update_option($name, $value);
  }

  function get()
  {
    $val = CbroCommon::get_option(self::chat_list, $this->non_existent_chats);

    if ($val === $this->non_existent_chats)
      throw new CbroChatsNotFound(self::chat_list);

    return $val;
  }

  function set($value)
  {
    self::update_option(self::chat_list, $value);
  }

  function postpone_write()
  {
  }

  function flush()
  {
  }

  function del()
  {
    CbroCommon::delete_option(self::chat_list);
  }
}

?>